From 1b1493ba9bcd259fe131d511d21da265d92f7d7e Mon Sep 17 00:00:00 2001
From: Eric Barbour <ebarbour@redhat.com>
Date: Aug 10 2016 19:35:20 +0000
Subject: [PATCH 610/1001] Data for Mentions, stream, and actions


---

diff --git a/hubs/app.py b/hubs/app.py
index 957a809..67cad13 100755
--- a/hubs/app.py
+++ b/hubs/app.py
@@ -52,6 +52,7 @@ import fedmsg.meta
 
 fedmsg_config = fedmsg.config.load_config()
 fedmsg.meta.make_processors(**fedmsg_config)
+paths = fmn.lib.load_rules(root='fmn.rules')
 
 session = hubs.models.init(fedmsg_config['hubs.sqlalchemy.uri'])
 datanommer.models.init(fedmsg_config['datanommer.sqlalchemy.uri'])
@@ -525,15 +526,91 @@ def login_required(function):
 @app.route('/<name>/stream/')
 @login_required
 def stream(name):
-    feeds = [
-        {'url': '', 'name': 'streamFeed', 'matches': []},
-        {'url': '', 'name': 'actionsFeed', 'matches': []},
-        {'url': '', 'name': 'mentionsFeed', 'matches': []},
-    ]
     saved = hubs.models.SavedNotification.by_username(session, name)
     saved = [n.__json__() for n in saved]
 
-    return flask.render_template('stream.html', feeds=json.dumps(feeds), saved=json.dumps(saved))
+    actions_rule = {
+        'filters': [{
+            'created_on': 'Thu, 15 Jan 2015 16:07:43 GMT',
+            'id': 20506,
+            'name': 'Events referring to my username',
+            'oneshot': None,
+            'rules': [
+                {
+                    'arguments': {
+                        'fasnick': name
+                    },
+                    'cache_key': '2f59dcddf85cab5822af8d40d82c7390ce0f80b40119f2db67f3037a0594a2a1',
+                    'code_path': 'fmn.rules:user_filter',
+                    'created_on': 'Thu, 15 Jan 2015 16:07:43 GMT',
+                    'info': {
+                        'args': [
+                            'config',
+                            'message',
+                            'fasnick'
+                        ],
+                        'datanommer-hints': {},
+                        'doc': "<p>Use this rule to include messages that are associated with a\nspecific user.</p>",
+                        'doc-no-links': '<html><head></head><body><p>Use this rule to include messages that are associated with a\nspecific user.</p>\n</body></html>',
+                        'hints-invertible': True,
+                        'submodule': 'generic',
+                        'title': 'A particular user'
+                    },
+                    'negated': False
+                }]
+        }]
+    }
+    actions_rule = hubs.widgets.feed.rehydrate_preference(actions_rule)
+    messages = []
+    matches = []
+
+    delta = datetime.timedelta(days=365)
+    end = datetime.datetime.utcnow()
+
+    fmn_hinting = fmn.lib.hinting.gather_hinting(fedmsg_config, actions_rule['filters'][0]['rules'], paths)
+    total, pages, rows = datanommer.models.Message.grep(
+        start=end - delta,
+        end=end,
+        rows_per_page=100,
+        page=1,
+        order='desc',
+        **fmn_hinting
+    )
+    messages.extend(rows)
+
+    for message in messages:
+        original = message.__json__()
+        if name in fedmsg.meta.msg2usernames(original, **fedmsg_config):
+            matches.append(original)
+
+    # Smash multiple messages into single ones
+    matches = fedmsg.meta.conglomerate(matches, lexers=True, **fedmsg_config)
+
+    # Apply some html markup to the subtitles for extra fanciness.
+    for match in matches:
+        match['markup'] = hubs.widgets.feed.apply_markup(match)
+        for idx, constituent in match['msg_ids'].items():
+            constituent['markup'] = hubs.widgets.feed.apply_markup(constituent)
+            if constituent['long_form'] != constituent['subtitle']:
+                if constituent.get('lexer'):
+                    constituent['long_form'] = pygments.highlight(
+                        constituent['long_form'],
+                        constituent['lexer'],
+                        pygments.formatters.HtmlFormatter(style='monokai'),
+                    )
+                else:
+                    markup = u"<h5>{long_form}</h5>".format(**constituent)
+                    constituent['long_form'] = markup
+
+        # And tack on a unique identifier for each top level entry.
+        match['dom_id'] = six.text_type(uuid.uuid4())
+
+    matches = json.dumps(matches, cls=hubs.widgets.feed.PythonObjectEncoder)
+    return flask.render_template(
+        'stream.html',
+        saved=json.dumps(saved),
+        actions=matches
+    )
 
 
 @app.route('/<user>/notifications', methods=['GET', 'POST'])
@@ -563,7 +640,7 @@ def notifications(user):
         session.add(notification)
         session.commit()
         return flask.jsonify(
-            dict(notification=notification.__json__(),success=True)
+            dict(notification=notification.__json__(), success=True)
         )
 
 @app.before_request
diff --git a/hubs/static/client/app/components/Markup.jsx b/hubs/static/client/app/components/Markup.jsx
index 66f4da4..f2464fe 100644
--- a/hubs/static/client/app/components/Markup.jsx
+++ b/hubs/static/client/app/components/Markup.jsx
@@ -6,6 +6,7 @@ export default class Markup extends React.Component {
     return { __html: this.props.match.markup };
   }
   render() {
+    const timestamp = this.props.date_time ? (<TimeAgo date={this.props.match.date_time} />) : null;
     return (
       <div className="media-body">
         <h4
@@ -13,7 +14,7 @@ export default class Markup extends React.Component {
           dangerouslySetInnerHTML={this.createMarkup()}
         >
         </h4>
-        <TimeAgo date={this.props.match.date_time} />
+        {timestamp}
       </div>
     );
   }
diff --git a/hubs/static/client/app/components/Panel.jsx b/hubs/static/client/app/components/Panel.jsx
index a5aa178..1651554 100644
--- a/hubs/static/client/app/components/Panel.jsx
+++ b/hubs/static/client/app/components/Panel.jsx
@@ -26,7 +26,10 @@ const Panel = function (props) {
       console.log(resp);
     });
   }
-  const button = (<button id={'save' + props.match.idx} onClick={onClick.bind(this, payload)} className="btn btn-default">SAVE</button>);
+  const button = props.match.saved
+               ? null
+               : (<button id={'save' + props.match.idx} onClick={onClick.bind(this, payload)} className="btn btn-default">SAVE</button>);
+
 
   return (
     <div className="panel panel-default panel-visible">
